dxfFileName = "MagicShifter_case18.dxf";


module extrudeLayer(layerName, height, zOffset = 0)
{
	translate([0,0,zOffset + (height< 0 ? height : 0)])
		linear_extrude(convexity = 5, height = abs(height), center = false)
			import_dxf(file = dxfFileName, layer = layerName, convexity = 6, scale=1);
}

module extrudeLayerLeft(layerName, height)
{
	translate([-height/2,0,0])
		rotate([0,90,0]) 
			translate([20,0,0]) 
				extrudeLayer(layerName, height);
}

module extrudeLayerPort(layerName, height)
{
	translate([0, height/2,0])
		rotate([90,0,0]) 
			translate([0,-30,0]) 
				extrudeLayer(layerName, -height);
}

module extrudeLayerStarboard(layerName, height)
{
	translate([0, -height/2,0])
		rotate([-90,0,0]) 
			translate([0,30,0]) 
				extrudeLayer(layerName, -height);
}



//translate([-10,0,0])
//rotate([0,90,0]) translate([30,0,0]) extrudeLayer("bottom_cut_left", 20);

$fn=8;




pcbHeight=1.25;
// z = 0
pcbToFloorH = 2;
floorH=1;
b_transparentH=0.2;
nonUSBH = 1.5;

ledSafetyDelta=0.5;
ledHeight = 2;
lidH = 1;
windowH=0.4;

TOTAL=pcbToFloorH+floorH;

echo(TOTAL);

totalH=(6.3)*2 +windowH;




// BOTTOM

// pcb
//%extrudeLayer("pcb", 1, floorH+pcbToFloorH);

union() {
	extrudeLayer("bottom_02", floorH+pcbToFloorH-0.5, 0.5);
	
	difference() 
	{
		extrudeLayer("pcb_outher_frame", floorH+pcbToFloorH+pcbHeight-0.5, 0.5);
		extrudeLayer("pcb_frame", totalH, 0);
	}

	difference()
	{
		union() {
			extrudeLayer("window", windowH, -windowH);
			extrudeLayer("bottom_00_anne3", nonUSBH, 0);
			extrudeLayer("bottom_00_anne_usb", totalH-1, 0.5);
			extrudeLayer("bottom_00_anne3", nonUSBH, totalH-nonUSBH);
			
		}	
		extrudeLayer("bottom_01", totalH, floorH);
		extrudeLayer("pcb_frame", 1.2, floorH+pcbToFloorH, color=4);
		extrudeLayerLeft("bottom_cut_left", 10);
		extrudeLayerPort("bottom_cut_port", 20);
		extrudeLayerStarboard("bottom_cut_starboard", 20);
	
		extrudeLayer("top_00_better", lidH + 1, totalH-lidH);
	}
}

// TOP
translate([0,50,totalH]) rotate([180,0,0])
union() {
	intersection() {
		extrudeLayerPort("top_cut_port", 20);
		extrudeLayer("top_port", totalH, 0);
	}
	extrudeLayer("top_00_better", lidH, totalH-lidH);
}