function ajaxLoad()
{
	$('#ajax_loader').show();
}

function ajaxUnload()
{
	$('#ajax_loader').hide();
}

function add_images(thing_id)
{
	ajaxLoad();
	$('#add_images_button').attr('disabled', true);
	
	$('#manageimages').load('/ajax/things/addimages',
    {
			'id': thing_id,
			'image_ids': $('#image_ids').val()
		},
		function() {
			ajaxUnload();
			$('#add_images_button').removeAttr('disabled');
			$('#image_ids')[0].value = '';
		}
	);
}

function add_user_profile_image(user_id)
{
	ajaxLoad();
	$('#add_image_button').attr('disabled',true);
	
	$('#current-profile-image-image').load('/ajax/user/add_image_by_url',
    {
			'id': user_id,
			'image_id': $('#image_id').val()
		},
		function() {
			ajaxUnload();
			$('#add_image_button').removeAttr('disabled');
			$('#image_id')[0].value = '';
		}
	);
}

/* FIXME: reg. this differently and prevent default */
function set_thumbnail(thing_id, image_id)
{
	ajaxLoad();
	$('#set_thumb_' + image_id).attr('disabled',true);

	$('#manageimages').load( '/ajax/things/setthumbnail',
    {
			'id': thing_id,
			'image_id': image_id
		},
		function() {
			ajaxUnload();
			$('#set_thumb_' + image_id).removeAttr('disabled');
		}
	);
}

/* FIXME: reg. this differently and prevent default. where is it used? */
function render_image(image_id)
{
	ajaxLoad();
	$('#render_image_' + image_id).attr('disabled',true);

	$.post('/ajax/render/resize_image', { 'id': image_id },
		function() {
			ajaxUnload();
			$('#render_image_' + image_id).removeAttr('disabled');
		}
	);
}

/* FIXME: reg. this differently and prevent default */
function delete_image(image_id)
{
	ajaxLoad();
	$('#delete_image_' + image_id).attr('disabled',true);

	$('#manageimages').load( '/ajax/things/deleteimage',
    { 'image_id': image_id }, ajaxUnload);
}

function reorder_thing_images(thing_id, image_ids)
{
  $.post( '/ajax/things/orderimages',
    { 'thing_id': thing_id, 'image_ids': image_ids });
}

function delete_file(file_id)
{
	ajaxLoad();
	$('#delete_file_' + file_id).attr('disabled', true);

	$('#managefiles').load( '/ajax/things/deletefile',
    { 'file_id': file_id }, ajaxUnload );
}

function render_file(file_id)
{
	//$('render_file_' + file_id).disable();
	
	$.post('/ajax/things/renderfile', { 'file_id': file_id });
}

function add_tags(thing_id)
{
	ajaxLoad();
	$('#add_tags_button').attr('disabled', true);

	$('#managetags').load( '/ajax/things/addtags',
    {
			'id': thing_id,
			'tags': $('#tags_to_add').val()
		},
		function() {
			ajaxUnload();
			$('#tags_to_add')[0].value = '';
			$('#add_tags_button').removeAttr('disabled');
		}
	);
}

function public_add_tag(thing_id)
{
	ajaxLoad();
	$('#new_tags_submit').attr('disabled', true);
		
	$('#thing-tag-list').load( '/ajax/things/addtags',
    {
			'id': thing_id,
			'tags': $('#new_tags').val(),
			'public': 1			
		},
		function() {
			ajaxUnload();
      $('#new_tags_submit').removeAttr('disabled');
			$('#new_tags')[0].value = '';
		}
	);
}

function add_tag(ele, thing_id, tag)
{
	ajaxLoad();
	
	$(ele).hide();

	$('#managetags').load( '/ajax/things/addtags',
    { 'id': thing_id, 'tags': tag }, ajaxUnload );
}


function remove_tag(thing_id, tag_id)
{
	ajaxLoad();

	$('#managetags').load( '/ajax/things/deletetag',
    { 'thing_id': thing_id, 'tag_id': tag_id }, ajaxUnload );
}

function feature_thing(thing_id)
{
	$('#feature-btn').load( '/ajax/things/feature', { 'id': thing_id } );
}

function unfeature_thing(thing_id)
{
	$('#feature-btn').load( '/ajax/things/unfeature', { 'id': thing_id } );
}

function setup_featured_things(featured_things)
{
  window.keepRotating = true;
  var elems_to_fade = '#featured-image, #featured-meta';
  $('#featured-image img').load(function(){
    $(elems_to_fade).fadeIn('fast');
  });
  $('#featured-nav-numbers li').each(function(i,ele){
    var e = $(ele);
    var thing = featured_things[i];
    /* pre-fetch images
    for(url in [thing.thumbnail, thing.creator.avatar]) {
      var tmpimg = new Image(); tmpimg.src = url;
    } // */
    e.mouseup(function(){
      keepRotating = false;
    });
    e.click(function(){
      if($(this).hasClass('active')) { return; }

      // update the nav to show the active thing
      $('#featured-nav-numbers li').each(function(j,ele){
        var e1 = $(ele);
        if(i === j)
          e1.addClass('active');
        else
          e1.removeClass('active');
      });

      // update the featured thing info
      $(elems_to_fade).fadeOut('fast', function() {
        $('#featured-image a')[0].href = thing.url;
        $('#featured-image img')[0].src = thing.thumbnail;
        $('#featured-image img')[0].alt = thing.name;
        $('#featured-image img')[0].title = thing.name;
        $('#featured-name a')[0].href = thing.url;
        $('#featured-name a').text(thing.name);
        $('#featured-description').html(thing.description);
        $('#featured-creator a')[0].href = thing.creator.url;
        $('#featured-creator a')[1].href = thing.creator.url;
        $('#featured-creator a').eq(1).html(thing.creator.name);
        $('#featured-creator .byline div:last-child').text(new Date(thing.add_date).toRelativeTime());
        if(thing.creator.avatar == null){
          $('#featured-creator img')[0].src = '/img/default/rendering_thumb_small.jpg';
        } else {
          $('#featured-creator img')[0].src = thing.creator.avatar;
        }
        //$('#featured-card').fadeIn('fast'); // now handled by the image load at top
      });
    });
  });

  $('#featured-left-arrow').click(function(){
    keepRotating = false;
    moveBackward();
  });

  $('#featured-right-arrow').click(function(){
    keepRotating = false;
    moveForward();
  });
  
  //Every 5 seconds, move forward
  setTimeout('autorotate()',5000);
}

function moveForward(){
  var ele = $('#featured-nav-numbers li.active').next();
  if(ele.length !== 0)
    ele.click();
  else
    $('#featured-nav-numbers li:first-child').click(); 
}

function moveBackward(){
  var ele = $('#featured-nav-numbers li.active').prev();
  if(ele.length !== 0)
    ele.click();
  else
    $('#featured-nav-numbers li:last-child').click();
}

function autorotate(){
    if (keepRotating) {
      moveForward();
      setTimeout('autorotate()',5000);
    }
}

function confirm_page_exit(){
    if (needToConfirm) return "You have unsaved data in your Thing's name, description, and instructions fields... in order to not lose data, please click 'Save' before leaving this page.";
}

function add_user_things_tab_listener(ele,idx){
  var my_div = $('#user-things >div').eq(idx);
  var e = $(ele);
  e.click(function(evt){
    evt.preventDefault();
    // give me the active class
    $('#user-things-tabs li').each(function(j,elm){
      if(j == idx){
        $(elm).addClass('active');
        e.unbind('click');
      } else {
        if($(elm).hasClass("active")){
          $(elm).removeClass('active');
          add_user_things_tab_listener(elm,j);
        }
      }
    });
    // fade out all the things sections, the fade in mine
    $('#user-things >div').filter(':visible').eq(0).hide();
    my_div.fadeIn('fast');
  });
}

function setup_user_things_tabs() {
  $('#user-things-tabs li a').each(function(idx,ele){
    var e = $(ele);
    if(! e.parent().hasClass('active')){
      add_user_things_tab_listener(ele,idx);
    }
  });
}

function toggle_like(thing_id)
{
	ajaxLoad();
  $('#thing-like').load('/ajax/things/toggle_like', {'id': thing_id }, ajaxUnload);
  return false;
}

function toggle_follow_thing(target_id)
{
  ajaxLoad();
  $('#follow').load('/ajax/dashboard/set_thing_subscribe_state', {'action': 'toggle', 'target_id': target_id}, ajaxUnload);
  Thingiverse.subscriptions.poll();
  return false;
}

function toggle_follow_user(target_id)
{
  ajaxLoad();
  $('#follow').load('/ajax/dashboard/set_user_subscribe_state', {'action': 'toggle', 'target_id': target_id}, ajaxUnload);
  Thingiverse.subscriptions.poll();
  return false;
}

function manage_unsubscribe(subscription_id)
{
  ajaxLoad();
  $('#edit-subscriptions').load('/ajax/dashboard/manage_unfollow',
    {
      'id': subscription_id
    },
    ajaxUnload);
}

function recommend_subscribe(target_type, target_id)
{
	ajaxLoad();
	$('#subscription_view_container').load('/ajax/dashboard/recommend_subscribe',
		{
			'target_type': target_type,
			'target_id': target_id
		}
	);
}

function flag_thing(thing_id)
{
  alert("Implement Me!");
}

function check_upload_form(ele)
{
	var form = $(ele)[0];

	var filename = form['file'].value;
	filename = filename.replace(/^.*[\\\/]/, '');

	//error checking.
	if (!filename || filename.length == 0)
	{
		alert("You must select a file.");
		return false;
	}
	
	//figure out our extension
	var dot = filename.lastIndexOf('.');
	var extension = '';
	if (dot != -1)
		extension = filename.substr(dot+1,filename.length); 

	//figure out our MIME/content-type and do something with it.
	var contentType = find_mime_type(extension);
	form['Content-Type'].value = contentType;

	//this is for prompting a download.
	if (contentType != 'application/octet-stream')
		form['Content-Disposition'].value = "";
	else
		form['Content-Disposition'].value = "Content-disposition: attachment; filename=" + filename;

	return true;
}

function find_mime_type(ext)
{
	ext = ext.toLowerCase();
	
	var mime_types = {
		pdf: 'application/pdf',
		zip: 'application/zip',
		tar: 'application/x-tar',
		tgz: 'application/x-tar',
		rar: 'application/x-rar-compressed',
		p3d: 'application/x-p3d',
		stl: 'application/sla',
		eps: 'application/postscript',
		ai: 'application/postscript',
		ps: 'application/postscript',
		ccad: 'application/clariscad',
		latex: 'application/x-latex',
		dvi: 'application/x-dvi',
		rtf: 'application/rtf',
		cdr: 'application/coreldraw',

		gif: 'image/gif',
		jpe: 'image/jpeg',
		jpg: 'image/jpeg',
		png: 'image/png',
		jpeg: 'image/jpeg',
		tiff: 'image/tiff',
		dwg: 'image/vnd.dwg',
		dxf: 'image/vnd.dxf',
		svg: 'image/svg+xml',
		svf: 'image/vnd.svf',
		epsi: 'image/x-eps',
		epsf: 'image/x-eps',
		lwo: 'image/x-lwo',

		
		iv: 'graphics/x-inventor',

		iges: 'model/iges',
		igs: 'model/iges',
		wrl: 'model/vrml',
		vrml: 'model/vrml',
		msh: 'model/mesh',
		mesh: 'model/mesh',
		silo: 'model/silo',
		dwf: 'model/vnd.dwf',
		'3dml': 'model/vnd.flatland.3dml',
		'3dm': 'model/vnd.flatland.3dml',
		gdl: 'model/vnd.gdl',
		dsm: 'model/vnd.gdl',
		win: 'model/vnd.gdl',
		dor: 'model/vnd.gdl',
		lmp: 'model/vnd.gdl',
		rsm: 'model/vnd.gdl',
		msm: 'model/vnd.gdl',
		ism: 'model/vnd.gdl',
		gtw: 'model/vnd.gtw',
		moml: 'model/vnd.moml+xml',
		mts: 'model/vnd.mts',
		x_b: 'model/vnd.parasolid.transmit-binary',
		x_t: 'model/vnd.parasolid.transmit-text',
		vtu: 'model/vnd.vtu',
		x3d: 'model/x3d+xml',
		pov: 'model/x-pov',
		
		txt: 'text/plain',
		htm: 'text/html',
		html: 'text/html'
	};
	
	var type = mime_types[ext];
	
	//standard default.
	if (!type)
		type = 'application/octet-stream';
		
	return type;
}

function render_js_template(tmpl_name, context)
{
  var tmpl = $('#' + tmpl_name).html();
  return _.template(tmpl, context);
}

function init_login_form()
{
  $('#ajax-login-form').submit(function(e){
      e.preventDefault();
      var usr = $('#usr').val();
      var pwd = $('#pwd').val();
      if ($('#rememberme').is(':checked')){
        var rmb = 1;
      } else {
        rmb = 0;
      }   
  
      $.ajax({
        url: '/login',
        type: 'POST',
        data: {
          username: usr,
          password: pwd,
          rememberme: rmb,
          submit: 'Login',
          requestmode: 'ajax'
        },
        dataType: "json",
        success: function(r) { 
          if ( r.loggedin == 'true' ) { // If the login worked, refresh page.
            location.reload(true);
          } else { // else run the error function.
            ajax_login_error();
          } 
        },
        error: ajax_login_error
      });
  });
}

function ajax_login_error() {
  $('#ajax-login').addClass('error');
  $('#ajax-login-terms').hide();
  $('#ajax-login-error').show();
}



function init_ancestor_search_form()
{
  $('#ancestor_search').click(function(event){
      event.stopPropagation();
      var thing_id = $('#ancestor_search_thing_id').val();
      var re_match = thing_id.match(/^(.*\/thing:)?([0-9][0-9]*)$/);
      if(re_match == null){
          show_ancestor_error("Could not understand '" + thing_id + "'.");
      } else {
        thing_id = re_match[2];
        $('#new_ancestor_btn').show();
        $.ajax({
            url: '/thing:' + thing_id,
            dataType: 'json',
            success: show_ancestor_update_form,
            error: function(){
                show_ancestor_error("Could not find a thing with ID '" + thing_id + "'.");
            }
        });
      }
   });
   change_enter_behavior('#ancestor_search_thing_id', function(){$('#ancestor_search').click();});

  $('#new_ancestor_btn').click(add_ancestor);
  $('#new_ancestor_btn').attr('disabled', true);
}

function insert_ancestor_form(ancestor)
{
  var re_match = document.location.pathname.match(/^.*\/thing:([0-9][0-9]*)(\/.*)?$/);
  var thing_id = re_match[1];
  var content = render_js_template('ancestor_template', ancestor);
  $(content).appendTo('#current-ancestors');
  $('#thing-ancestor-' + ancestor.id + ' .remove-ancestor-btn').click(function(){
    remove_ancestor(thing_id, ancestor.id);
  }).show();
  $('#current-ancestors').show(); 
}

function remove_ancestor(thing_id, ancestor_id)
{
  $.ajax({
      url: '/thing:' + thing_id + '/drop_ancestor:' + ancestor_id,
      dataType: 'json',
      success: function(data){
        $('#thing-ancestor-' + ancestor_id).remove();
      },
      error: function(err){
          show_ancestor_error(err);
      }
  });
}

function show_ancestor_error(message)
{
  $('#new_ancestor_content').html("<div class='BaseError'>" + message + "</div>");
  $('#new_ancestor_btn').hide();
  $('#new_ancestor').show();
}

function show_ancestor_update_form(thing){
    var content = render_js_template('ancestor_template', thing);
    $('#new_ancestor_content').html(content);
    $('#new_ancestor_thing_id')[0].value = thing.id;
    var sub_btn = $('#new_ancestor_btn');
    if(thing.license.allows_derivatives){
        sub_btn.removeAttr('disabled');
        sub_btn.show();
    } else {
        sub_btn.attr('disabled',true);
    }
    $('#new_ancestor').show();
}

function add_ancestor(){
  var re_match = document.location.pathname.match(/^.*(\/thing:[0-9][0-9]*)(\/.*)?$/);
  var thing_url = re_match[1];
  var anc_id = $('#new_ancestor_thing_id').val();
  var action = thing_url + "/add_ancestor:" + anc_id;
  $.ajax({
      url: action,
      dataType: 'json',
      success: function(data){
        insert_ancestor_form(data);
        $('#new_ancestor').hide();
        $('#ancestor_search_thing_id')[0].value = '';
      },
      error: function(err){
          show_ancestor_error(err);
      }
  });
}

function show_same_design_options()
{
	$('#modified_design').hide();
	$('#same_design').show();
	$('#image_ids').focus();
}

function show_modified_design_options()
{
	$('#same_design').hide();
	$('#modified_design').show();
}

function add_derivative_image(derivative_id)
{
	ajaxLoad();
	$('#add_image_button').attr('disabled',true);
	
	$('#current_image').load( '/ajax/derivative/set_image',
    {
			'id': derivative_id,
			'image_id': $('#image_id')[0].value,
		},
		function() {
			ajaxUnload();
			$('#add_image_button').removeAttr('disabled');
			$('#image_id')[0].value = '';
		}
	);	
}

function empty_render_queue()
{
	ajaxLoad();
	
	$('#result').load( '/ajax/admin/empty_render_queue', ajaxUnload );	
}

function empty_background_queue()
{
	ajaxLoad();
	
	$('#result').load( '/ajax/admin/empty_background_queue', ajaxUnload );	
}

function empty_completed_queue()
{
	ajaxLoad();
	
	$('#result').load( '/ajax/admin/empty_completed_queue', ajaxUnload );	
}

function remove_tool_category_link(link_id)
{
	ajaxLoad();
	$('#tool_cat_link_' + link_id).hide();
	
	$.post('/ajax/tool/delete_category', { 'link_id': link_id }, ajaxUnload );
}

function add_thing_tool(ele, thing_id, tool_id)
{
	ajaxLoad();
	$(ele).hide();
	
	$('#thing-tools-list-container').load( '/ajax/things/add_tool',
    { 'thing_id': thing_id, 'tool_id': tool_id }, ajaxUnload );
}

function remove_thing_tool(ele, link_id)
{
	$.post( '/ajax/things/remove_tool', { 'link_id': link_id },
    function() {
      var tool_id = ele.id;
      tool_id = tool_id.replace(/^remove-tool-/,'');
      $('.all-tools-container li#add-tool-' + tool_id).show();
      $(ele).remove();
      ajaxUnload();
    });
}

function add_user_tool(ele, user_id, tool_id)
{
	ajaxLoad();
	$(ele).hide();
	
	$('#user-tools-list-container').load( '/ajax/user/add_tool',
    { 'user_id': user_id, 'tool_id': tool_id }, ajaxUnload );
}

/** FIXME: the redraw closes any open tool categories */
function remove_user_tool(ele, link_id)
{
	ajaxLoad();
	$.post( '/ajax/user/remove_tool', { 'link_id': link_id },
    function() {
      var tool_id = ele.id;
      tool_id = tool_id.replace(/^remove-tool-/,'');
      $('.all-tools-container li#add-tool-' + tool_id).show();
      $(ele).remove();
      ajaxUnload();
    });
}

function add_tool(ele, user_id, tool_id)
{
	ajaxLoad();
	ele.disable();
	
	$('#tool_shop_action').load( '/ajax/user/add_tool',
    {
			'user_id': user_id,
			'tool_id': tool_id,
			'single_tool': 1
		},
		ajaxUnload
	);
}

function remove_tool(ele, link_id)
{
	ajaxLoad();
	ele.disable();
	
	$('#tool_shop_action').load( '/ajax/user/remove_tool',
    { 'link_id': link_id, 'single_tool': 1 }, ajaxUnload );
}

function add_thing_category(elem_id, thing_id)
{
	ajaxLoad();

  var params = $(elem_id).serializeObject();
  params['id'] = thing_id;
	$('#managecategories').load( '/ajax/things/add_category', params, ajaxUnload );
}

function remove_thing_category(link_id)
{
  ajaxLoad();

  $('#managecategories').load( '/ajax/things/remove_category',
    { 'link_id': link_id }, ajaxUnload );
}

function resizeIframeToFitContent(frame)
{
	if (document.frames)
	{
		frame.height = 300;
	}
	else
	{
		var innerDoc = (frame.contentDocument) ? frame.contentDocument : frame.contentWindow.document;
		var realHeight = 0;
		
		if (innerDoc.height)
			realHeight = innerDoc.height;
		else if (innerDoc.body.offsetHeight)
			realHeight = innerDoc.body.offsetHeight
		
		if (realHeight)
		  frame.style.height = realHeight + 'px';
	}
}

function selectAll(ele)
{
	ele.focus();
	ele.select();
}

/* FIXME: may have to replace this where it is used with change_enter_behavior */
function checkEnter(e){ //e is event object passed from function invocation
	var characterCode //literal character code will be stored in this variable

	if(e && e.which){ //if which property of event object is supported (NN4)
		e = e
		characterCode = e.which //character code is contained in NN4's which property
	}
	else{
		e = event
		characterCode = e.keyCode //character code is contained in IE's keyCode property
	}

	if(characterCode == 13){ //if generated character code is equal to ascii 13 (if enter key)
		return true
	}
	else{
		return false
	}
}

/** Poll Editing **/

function poll_add_answer(poll_id)
{
	ajaxLoad();
	$('#manage_answers').load( '/ajax/polls/add_answer',
    { 'id': poll_id }, ajaxUnload );
}

function poll_update_answer(answer_id)
{
  ajaxLoad();
  $('#manage_answers').load( '/ajax/polls/update_answer',
    {
      'id': answer_id,
      'answer': $('#poll_answer_' + answer_id).val()
    },
		function() {
      /* FIXME: requires jQuery UI Effects */
      $('#poll_answer_' + answer_id).effect("highlight",{},3000);
      ajaxUnload();
    }
  );
}

function poll_delete_answer(answer_id)
{
  ajaxLoad();
  $('#manage_answers').load( '/ajax/polls/delete_answer',
    { 'id': answer_id, }, ajaxUnload );
}

function poll_submit_response()
{
  var poll_form = $('#sidebar_poll_form')[0];
	ajaxLoad();
	$('#poll_status').load( poll_form.action, 
    poll_form.serializeObject,
		ajaxUnload
	);
}

function arrow_toggle(ele_id)
{
  $("#" + ele_id).toggle('fast');
  var arrow_img = $("#" + ele_id + "-toggle img")[0];
  if(/-expanded.png$/.test(arrow_img.src)) {
    arrow_img.src = arrow_img.src.replace(/expanded/,"unexpanded");
  } else {
    arrow_img.src = arrow_img.src.replace(/unexpanded/,"expanded");
  }
}

function change_enter_behavior(selector, new_behavior)
{
  var fields = $(selector);
  var callback = function(event) {
    if(event.keyCode == 13) {
      new_behavior();
      event.preventDefault();
      event.stopPropagation();
      return false;
    }
  };
  if ($.browser.mozilla) {
    $(fields).keypress(callback);
  } else {
    $(fields).keydown(callback);
  }
}

/** attach_sort_events({container: 'selector', ... }) */
function attach_sort_events(options)
{
  var defaults = {
    'sortable_selector': '> *',
    'map': {}
  };
  var opts = $.extend({}, defaults, options);
  $.each(opts['map'], function(selector, data_attr) {
    $(selector).click(function(elem){
      var sort_dir = $(this).hasClass("ascending") ? 'descending' : 'ascending';
      $.each(opts['map'], function(sel, ign){
        $(sel).removeClass('ascending');
        $(sel).removeClass('descending');
      });
      $(this).addClass(sort_dir);
      sort_by_data_attribute(opts['container'], opts['sortable_selector'], data_attr, sort_dir);
    });
  });
}

function sort_by_data_attribute(container, child_selector, data_attr, sort_dir){
  var sort_elems = $(container).find(child_selector);
  $.each(sort_elems, function(idx,el){ $(el).detach(); });
  var reverse = (sort_dir == 'ascending');
  sort_elems.sort(function(a,b){
    var av, bv;
    if(typeof(data_attr) == "function"){
      av = data_attr.call(a);
      bv = data_attr.call(b);
    } else {
      av = $(a).attr('data-' + data_attr);
      bv = $(b).attr('data-' + data_attr);
    }
    var check = ((av < bv) ? -1 : ((av > bv) ? +1 : 0)) * [-1,1][+!!reverse]; 
    if(check == 0){
      // sort by id for tiebreakers
      av = a.id;
      bv = b.id;
      return ((av < bv) ? -1 : ((av > bv) ? +1 : 0)) * [-1,1][+!!reverse]; 
    } else {
      return check;
    }
  });
  $.each(sort_elems, function(idx,el){ $(container).append(el); });
}

/* Turn a form into a hash of {name: value, name:[value,value],...} */
$.fn.serializeObject = function()
{
    var o = {};
    var a = this.serializeArray();
    $.each(a, function() {
        if (o[this.name] !== undefined) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
};

function uncheck_feature_all_users_for_feature(mask)
{
  var feature_boxes = $('input[name^="user_features"][name$="[' + mask + ']"]');
  feature_boxes.each(function(idx,e){ e.checked = false; });
}

function uncheck_feature_all_features_for_user(user_id)
{
  var user_boxes = $('input[name^="user_features[' + user_id + ']"]');
  user_boxes.each(function(idx,e){ e.checked = false; });
}

function feature_grid_add_user()
{
  var te = $('#features_add_user').textext()[0];
  var usernames = JSON.parse(
                      te.wrapElement()
                      .find('input[type="hidden"]')[0]
                      .value
                    );
  $(usernames).each(function(idx,username){
    var html = render_js_template('features_new_user_row', {'username': username});
    $("#user_features_grid tbody").append(html);
  });
  $('.text-tag a.text-remove').click();
}

/**
 * Javascript Relative Time Helpers
 * https://github.com/jherdman/javascript-relative-time-helpers
 *  The MIT License

 *  Copyright (c) 2009 James F. Herdman

 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:

 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.

 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *  THE SOFTWARE.
 * Returns a description of this past date in relative terms.
 * Takes an optional parameter (default: 0) setting the threshold in ms which
 * is considered "Just now".
 *
 * Examples, where new Date().toString() == "Mon Nov 23 2009 17:36:51 GMT-0500 (EST)":
 *
 * new Date().toRelativeTime()
 * --> 'Just now'
 *
 * new Date("Nov 21, 2009").toRelativeTime()
 * --> '2 days ago'
 *
 * // One second ago
 * new Date("Nov 23 2009 17:36:50 GMT-0500 (EST)").toRelativeTime()
 * --> '1 second ago'
 *
 * // One second ago, now setting a now_threshold to 5 seconds
 * new Date("Nov 23 2009 17:36:50 GMT-0500 (EST)").toRelativeTime(5000)
 * --> 'Just now'
 *
 */
Date.prototype.toRelativeTime = function(now_threshold) {
  var delta = new Date() - this;

  now_threshold = parseInt(now_threshold, 10);

  if (isNaN(now_threshold)) {
    now_threshold = 0;
  }

  if (delta <= now_threshold) {
    return 'Just now';
  }

  var units = null;
  var conversions = {
    millisecond: 1, // ms    -> ms
    second: 1000,   // ms    -> sec
    minute: 60,     // sec   -> min
    hour:   60,     // min   -> hour
    day:    24,     // hour  -> day
    month:  30,     // day   -> month (roughly)
    year:   12      // month -> year
  };

  for (var key in conversions) {
    if (delta < conversions[key]) {
      break;
    } else {
      units = key; // keeps track of the selected key over the iteration
      delta = delta / conversions[key];
    }
  }

  // pluralize a unit when the difference is greater than 1.
  delta = Math.floor(delta);
  if (delta !== 1) { units += "s"; }
  return [delta, units, "ago"].join(" ");
};

/*
 * Wraps up a common pattern used with this plugin whereby you take a String
 * representation of a Date, and want back a date object.
 */
Date.fromString = function(str) {
  return new Date(Date.parse(str));
};

/*
 * For client-side checking of collection names.
 */
String.prototype.getSlug = function(){
  var ret = jQuery.trim(this).toLowerCase();
  ret = ret.replace(/&/g, 'amp')
      .replace(/</g, 'lt')
      .replace(/>/g, 'gt')
      .replace(/"/g, 'quot')
      .replace(/'/g, '')
      .replace(/[^a-zA-Z0-9\/_|+ -]/g, '')
      .replace(/[\/_|+ -]+/g, '-');
  return ret;
}

/*
  Pre-slice print functions
*/

// open new print window
$('#show_add_print').click(function(e){
  // reset the state
  $('select[name=printer_id] option[value=1]').attr('selected', 'selected');
  $('input:text[name=print_name]').val('');
  $('input:radio[name=extruder_count][value=1]').attr('checked', 'checked').click();

  [1,2].map(function(extruder){
    $("[data-extruder='" + extruder + "'] .stl_file").each(function(other){
      $(this).removeClass('selected');
    });
  });
  
  $('#new_print_container').toggle();
});

// close new print window
$('#hide_add_print').click(function(e){
  $('#new_print_container').hide();
});

$('.stl_file').click(function(e){
  this_element = $(this);
  extruder = $(this).parent().data('extruder');
  extruder_count = $('input:radio[name=extruder_count]:checked').val();
  
  if (extruder == 1) {
    other_extruder = 2;
  } else {
    other_extruder = 1;
  }
  
  // hide this stl on the other extruder list
  $("[data-extruder='" + other_extruder + "'] .stl_file").each(function(other){
    $(this).show();
  });
  $("[data-extruder='" + other_extruder + "'] .stl_file[data-file-id=" + this_element.data('file-id') + "]").hide();
  
  // clear all other selections for this extruder, then selected the one clicked
  $("[data-extruder='" + extruder + "'] .stl_file").each(function(other){
    $(this).removeClass('selected');
  });
  
  this_element.addClass('selected');

  // build a suggested filename
  extruder1_name = ($('.print_stl_list[data-extruder=1] .stl_file.selected').data('file-name') || '').split('.').reverse().pop();

  if (extruder_count == 1) {
    suggested_filename = extruder1_name;
  } else {
    extruder2_name = ($('.print_stl_list[data-extruder=2] .stl_file.selected').data('file-name') || '').split('.').reverse().pop();
    suggested_filename = extruder1_name + '_' + extruder2_name;    
  }
  
  $('input:text[name=print_name]').val(suggested_filename.substring(0,22));
});

// change extruder count
$('input:radio[name=extruder_count]').click(function(e){ 
  if ($(this).val() == '1') {
    $('#single_instructions').show();
    $('#dual_instructions').hide();
    $('#extruder_labels').hide();
    $('[data-extruder=1]').show();
    $('[data-extruder=2]').hide();
    $('.print_stl_list[data-extruder=2] .stl_file.selected').click();
    $('.print_stl_list[data-extruder=2] .stl_file.selected').removeClass('selected');
  } else {
    $('#single_instructions').hide();
    $('#dual_instructions').show();
    $('#extruder_labels').show();
    $('[data-extruder=1]').show();
    $('[data-extruder=2]').show();
  }
});

$('#add_print').click(function(e){
  thing_id = $('#add_print').data('thing-id');
  printer_id = $('select[name=printer_id]').val();
  print_name = $('input:text[name=print_name]').val();
  extruder_count = $('input:radio[name=extruder_count]:checked').val();
  extruder1_file_id = $('.print_stl_list[data-extruder=1] .stl_file.selected').data('file-id');
  extruder2_file_id = $('.print_stl_list[data-extruder=2] .stl_file.selected').data('file-id');
  slicer_id = 1; // hardcoded TODO: future support for multiple slicers, 1 = skeinforge 35

  if (!printer_id) {
    alert('You must select a printer');
    return false;
  }

  if (!print_name) {
    alert('You must enter a print name');
    return false;
  }

  if (!extruder_count) {
    alert('You must select the number of extruders');
    return false;
  }

  if (!extruder1_file_id) {
    alert('You must select an STL file for extruder 1');
    return false;
  }
  
  if (extruder_count > 1) {
    if (!extruder2_file_id) {
      alert('You must select an STL file for extruder 2');
      return false;
    }
    
    if (extruder1_file_id == extruder2_file_id) {
      alert('You cannot select the same STL for both extruders');
      return false;
    }
  }  

	ajaxLoad();
  $('#add_print').attr('disabled','disabled');

  $.ajax({
    type: 'POST',
    url: '/ajax/things/add_print_job',
    data: {
      'id': thing_id,
      'printer_id': printer_id,
      'print_name': print_name,
      'extruder_count': extruder_count,
      'slicer_id': slicer_id,
      'extruder1_file_id': extruder1_file_id,
      'extruder2_file_id': extruder2_file_id
    },
    success: function(response) {
      $('#manageprints').html(response);
      $('#add_print').removeAttr('disabled');
      $('#new_print_container').hide();
      ajaxUnload();
    },
    error: function(e) {
      alert('Error: ' + e.responseText);
      $('#add_print').removeAttr('disabled');
      ajaxUnload();
    }
  });

});

$('.delete-print').live('click', function(e){
	if (confirm('Are you sure you want to delete this print job?')) {
		print_job_id = $(this).data('print-job-id');

	  $.ajax({
	    type: 'POST',
	    url: '/ajax/things/delete_print_job',
	    data: {
	      'id': print_job_id
	    },
	    success: function(response) {
	      $('#manageprints').html(response);
	      ajaxUnload();
	    },
	    error: function(e) {
	      alert('Error: ' + e.responseText);
	      ajaxUnload();
	    }
	  });
	}
});

$('.queue-print').live('click', function(e){
	print_job_id = $(this).data('print-job-id');

  $.ajax({
    type: 'POST',
    url: '/ajax/things/queue_print_job',
    data: {
      'id': print_job_id
    },
    success: function(response) {
      ajaxUnload();
    },
    error: function(e) {
      alert('Error: ' + e.responseText);
      ajaxUnload();
    }
  });
});

$('.toggle-verify-print').live('click', function(e){
	print_job_id = $(this).data('print-job-id');

	$.ajax({
		type: 'POST',
		url: '/ajax/things/toggle_print_verification',
		data: {
			'id': print_job_id
		},
		success: function(response) {
			$('#manageprints').html(response);
			ajaxUnload();
		},
		error: function(e) {
			alert('Error: ' + e.responseText);
			ajaxUnload();
		}
	});
});

$('.verify_print').live('click', function(e){
	thing_id = $(this).data('thing-id');

	$.ajax({
		type: 'POST',
		url: '/ajax/things/verify_print',
		data: {
			'id': thing_id
		},
		success: function(response) {
			$('#verify_buttons').html(response);
			ajaxUnload();
		},
		error: function(e) {
			alert('Error: ' + e.responseText);
			ajaxUnload();
		}
	});
});

// open new print window
$('#thing-print-jobs #print-button a').click(function(e){
	e.preventDefault();
  $('#print-download-window').toggle();
});

// close new print window
$('#print-download-window #ok-button').click(function(e){
  $('#print-download-window').hide();
	return false;
});

$('#print-instructions-button').click(function(e){
	e.preventDefault();
	$('#print-instructions').toggle();
});

$('#print-files #material-select input[="material_id"]:radio').change(function(e) {
	material_id = $(this).val();
	$('.print-file').hide();
	$('.print-file[data-material-id="' + material_id + '"]').show();
});

var Thingiverse = (function() {
	var self = {};

	self.subscriptions = (function() {
		var self = {};
    var currentPage = 1; // first page is 1

		function setState(state, type, id, callback) {
			$.ajax({
				"url":"/ajax/dashboard/set_subscribe_state",
				"type":"post",
				"data": {
					"action":state,
					"target_type":type,
					"target_id":id
				},
				"success": callback
			});
		};

		self.poll = function poll() {
			$.ajax("/ajax/dashboard/poll", {
				success: function(data) {
					if (data.activityCount > 99) {
						$('#nav-activity').html("&infin;").addClass("infin").show();
					}
					else if (data.activityCount > 0) {
						$('#nav-activity').html(data.activityCount).removeClass('infin').show();
					}
					else {
						$('#nav-activity').hide();
					}
				}
			});
		};

		self.isFollowing = function isFollowing(element) {
			return $(element).hasClass("is_following");
		};

		self.followClick = function followClick(type, id, element) {
			if (self.isFollowing(element)) {
				setState("unsubscribe", type, id, self.loadEvents);
				$(element).removeClass("is_following").addClass("not_following").children("a").html("Follow");
			}
			else {
				setState("subscribe", type, id, self.loadEvents);
				$(element).addClass("is_following").removeClass("not_following").children("a").html("Following");
			}
		};

		self.loadEvents = function loadEvents() {
			self.poll();

			if ($('#subscription_view_container').length) {
				ajaxLoad();
				$('#subscription_view_container').load('/ajax/dashboard/list_events', {}, ajaxUnload);
			}
		};

    self.nextPage = function() {
      currentPage+=1;

      $('#view_more_posts_button').addClass('hidden');
      $('#view_more_posts_status').removeClass('hidden');
      $.ajax({
        url: "/ajax/dashboard/list_events",
        type: 'POST',
        data: {
          page: currentPage
        },
				success: function(data, textStatus, jqXHR) {
          $('#subscription_view_container').append( data );
          if ( jQuery.trim(data).length )
            $('#view_more_posts_button').removeClass('hidden');
				},
        complete: function() {
          $('#view_more_posts_status').addClass('hidden');
        }
      });


    };

		return self;
	}());

	self.collections = (function() {
		var self = {};

    self.setCollectionDescription = function( collection_id, description ) {
      $.post('/ajax/thingcollection/set_description',
        {
           'collection_id': collection_id,
           'description': description
        }
      );
    }

    self.removeThing= function( thingcollection_link_id ) {
      $.post('/ajax/thingcollection/remove_thing',
        {
           'thingcollection_link_id': thingcollection_link_id
        },
        function() {
          window.location.reload();
        }
      );
    }

		return self;
	}());

	return self;
}());

function toggle_derivative_print_job(box, derivative_id, print_job_id) {
  $.ajax({
    type: 'POST',
    url: '/ajax/derivative/link_print_job',
    data: {
      'id': derivative_id,
      'print_job_id': print_job_id,
      'state': (box.checked == true ? '1' : '0')
    },
    success: function(response) {
      ajaxUnload();
    },
    error: function(e) {
      alert('Error: ' + e.responseText);
      ajaxUnload();
    }
  });
}